<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_TransportSupplier StructType
 * @subpackage Structs
 */
class JP_TransportSupplier extends AbstractStructBase
{
    /**
     * The TransportRates
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_TransportRate
     */
    public $TransportRates;
    /**
     * The Code
     * @var string
     */
    public $Code;
    /**
     * Constructor method for JP_TransportSupplier
     * @uses JP_TransportSupplier::setTransportRates()
     * @uses JP_TransportSupplier::setCode()
     * @param \ArrayType\ArrayOfJP_TransportRate $transportRates
     * @param string $code
     */
    public function __construct(\ArrayType\ArrayOfJP_TransportRate $transportRates = null, $code = null)
    {
        $this
            ->setTransportRates($transportRates)
            ->setCode($code);
    }
    /**
     * Get TransportRates value
     * @return \ArrayType\ArrayOfJP_TransportRate|null
     */
    public function getTransportRates()
    {
        return $this->TransportRates;
    }
    /**
     * Set TransportRates value
     * @param \ArrayType\ArrayOfJP_TransportRate $transportRates
     * @return \StructType\JP_TransportSupplier
     */
    public function setTransportRates(\ArrayType\ArrayOfJP_TransportRate $transportRates = null)
    {
        $this->TransportRates = $transportRates;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\JP_TransportSupplier
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
}
